momf_  <- function(theta) {
    sigma <- theta[1]
    gam   <- theta[2]
    rho   <- theta[3]
    alpha <- theta[4]
    beta  <- theta[5]
    N     <- length(non)
    kappa <- (1 - gam) / (1 - 1 / sigma)
    tmp_1 <- 1 - alpha + alpha * durnon ^ (1 - 1 / rho)
    tmp_2 <- 1 - alpha + alpha * Ldurnon ^ (1 - 1 / rho)

    if (min(tmp_1) <= 0.0 || min(tmp_2) <= 0.0 || beta < 0) {
      return(array(1, c(N, Nexc + 2)) * 1000)
    }
    
    lv   <- (1 / (1 - 1 / rho)) * log(tmp_1)
    lLv  <- (1 / (1 - 1 / rho)) * log(tmp_2)

    logM <- kappa * log(beta) - (kappa / sigma) * non + (kappa * (1 / rho - 1 /
                                                                   sigma)) * (lv - lLv) + (kappa - 1) * log(RW)
    M    <- exp(logM)
    Q    <- alpha / (1 - alpha) * Ldurnon ^ (-1 / rho)
    

    r1   <- (M * GrossRet - 1) * instrum

    mex  <- M * ExcessRet    
    r2   <- mex[,1]*instrum
    for (j in 2:Nexc) {
      r2 <- cbind(r2, instrum*c(mex[,j]))
    }

    r3 <- (1 - Q / Lprice - deprec * M * Rprice) * instrum
    
    g  <- cbind(r1, r2, r3)

    if (any(!is.finite(g))) {
        array(1, dim(g))*(.Machine$double.xmax^(1/46))
    } else {
      g
    }
}

dmomf_ <- function(theta) {
    sigma <- theta[1]
    gam   <- theta[2]
    rho   <- theta[3]
    alpha <- theta[4]
    beta  <- theta[5]

    K     <- 5
    N     <- nrow(ExcessRet)
    P     <- Ninst
    kappa <- (1 - gam) / (1 - 1 / sigma)
    tmp_1 <- 1 - alpha + alpha * durnon ^ (1 - 1 / rho)
    tmp_2 <- 1 - alpha + alpha * Ldurnon ^ (1 - 1 / rho)

    if (min(tmp_1) < 0.0 || min(tmp_2) < 0.0 || beta < 0 || rho < 0)
        return(array(1, c(Nmom, K))*10000)
    
    lv       <- (1 / (1 - 1 / rho)) * log(tmp_1)
    lLv      <- (1 / (1 - 1 / rho)) * log(tmp_2)

    v        <- exp(lv)
    Lv       <- exp(lLv)
    
    dvrho    <- 1 / (rho ^ 2 * (1 - 1 / rho)) * (alpha * v ^ (1 / rho - 1) * durnon ^
                                                (1 - 1 / rho) * log(durnon) - lv)
    Ldvrho   <- 1 / (rho ^ 2 * (1 - 1 / rho)) * (alpha * Lv ^ (1 / rho - 1) *
                                                Ldurnon ^ (1 - 1 / rho) * log(Ldurnon) - lLv)
    
    dvalpha  <- 1/(1-1/rho)*v^(1/rho-1)*(durnon^(1-1/rho)-1)
    Ldvalpha <- 1/(1-1/rho)*Lv^(1/rho-1)*(Ldurnon^(1-1/rho)-1)

    xi  <- ((gam-1)/(sigma*(sigma-1)^2)-kappa/sigma^2)
    zed <- ((gam-1)/(sigma-1)^2*(1/rho-1/sigma)+kappa/sigma^2)
    phi <- (gam-1)/(sigma-1)^2

    dMsigma  <- (gam-1)*log(beta)/(sigma-1)^2 - xi*non+zed*(lv-lLv)+phi*log(RW)

    xi      <- -log(beta) / (1 - 1 / sigma)
    zed     <- (1 / rho - 1 / sigma) / (1 - 1 / sigma)
    dMgam   <- xi+non/(sigma-1) - zed*(lv-lLv)-log(RW)/(1-1/sigma)

    dMrho   <- -kappa/rho^2*(lv-lLv)+kappa*(1/rho-1/sigma)*(dvrho-Ldvrho)

    dMalpha <- kappa*(1/rho-1/sigma)*(dvalpha-Ldvalpha)
    dMbeta  <- kappa/beta*array(1, N)

    
    logM    <- kappa*log(beta)-(kappa/sigma)*non+(kappa*(1/rho-1/sigma))*(lv-lLv)+(kappa-1)*log(RW)

    M       <- exp(logM)
    dM      <- M*cbind(dMsigma, dMgam, dMrho, dMalpha, dMbeta)
    
    Q       <- alpha/(1-alpha)*Ldurnon^(-1/rho)

    dQrho   <- Q*log(Ldurnon)/rho^2
    dQalpha <- Q/(alpha*(1-alpha))

    dQ   <- cbind(array(0, c(N, 2)), dQrho, dQalpha, array(0, N))
    
    mex  <- (GrossRet * instrum)
    if (P == 1) {
      dr1 <- dM * c(mex)
    } else {
      dr1 <- mex[, 1] * dM
      for (j in 2:P)
        dr1 <- cbind(dr1, mex[, j] * dM)
    }

    mex <- ExcessRet[,1]*instrum
    for (j in 2:(Nexc)) {
      mex <- cbind(mex, ExcessRet[,j]*instrum)
    }
    
    dr2 <- mex[, 1] * dM
    for (j in 2:(Nexc * P)) {
      dr2 <- cbind(dr2, mex[, j] * dM)
    }
    
    mex = -(instrum/Lprice)
    if (P == 1) {
      dr3_1 <- dQ * c(mex)
    } else {
      dr3_1 <- mex[, 1] * dQ
      for (j in 2:P) {
        dr3_1 <- cbind(dr3_1, mex[, j] * dQ)
      }
    }
    
    mex <- -(deprec*Rprice*instrum)
    if (P == 1) {
      dr3_2 <- dM * c(mex)
    } else {
      dr3_2 <- mex[, 1] * dM
      for (j in 2:P) {
        dr3_2  <- cbind(dr3_2, mex[, j] * dM)
      }
    }
    
    dr <- cbind(dr1, dr2, dr3_1 + dr3_2)

    drT <- matrix(colSums(dr), Nmom, K, byrow = TRUE)
    drT
}

